/* $Id: sha512.c 7 2023-02-12 09:26:11Z nishi $ */

#include <bpkgdb/sha512.h>

#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include <stddef.h>

#include <openssl/sha.h>

uint8_t* bpkgdb_sha512(const uint8_t* input, size_t length){
	SHA512_CTX ctx;
	uint8_t* buffer = malloc(512);
	SHA512_Init(&ctx);
	SHA512_Update(&ctx, (uint8_t*)input, length);
	SHA512_Final(buffer, &ctx);
	uint8_t* result = malloc(64);
	memcpy(result, buffer, 64);
	free(buffer);
	return result;
}
