/* $Id: util.c 7 2023-02-12 09:26:11Z nishi $ */

#include <bpkgdb/util.h>

#include <string.h>
#include <stdlib.h>

char* sstrdup(const char* str){
	char* result = malloc(strlen(str) + 1);
	result[strlen(str)] = 0;
	strcpy(result, str);
	return result;
}

char* sstrcat(const char* str1, const char* str2){
	char* result = malloc(strlen(str1) + strlen(str2) + 1);
	result[strlen(str1) + strlen(str2)] = 0;
	strcpy(result, str1);
	strcpy(result + strlen(str1), str2);
	return result;
}

char* sstrcat3(const char* str1, const char* str2, const char* str3){
	char* tmp = sstrcat(str1, str2);
	char* result = sstrcat(tmp, str3);
	free(tmp);
	return result;
}
